% this code collects the XLS data into one big matrix and does basic
% cleanup and aggergation
clear all
load ../Data/xlsdata

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Arrange matrices into a single matrix
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[I1,J1]=size(LVHD1); [I2,J2]=size(LVHD2); [I3,J3]=size(LVHD3);
[I4,J4]=size(LVHD4);[I5,J5]=size(LVHD5);
obs1=(J1-8)/2; obs2=(J2-8)/2; obs3=(J3-8)/2; obs4=(J4-8)/2; obs5=(J5-8)/2;
AGMTXp1=[LVHD1(:,1:8+obs1) nan(I1,obs2+obs3+obs4+obs5) ...
    LVHD1(:,8+obs1+1:8+2*obs1) nan(I1,obs2+obs3+obs4+obs5)];
AGMTXp2=[LVHD2(:,1:8)...
    nan(I2,obs1) LVHD2(:,8+1:8+obs2) nan(I2,obs3+obs4+obs5)...
    nan(I2,obs1) LVHD2(:,8+obs2+1:8+2*obs2) nan(I2,obs3+obs4+obs5)];
AGMTXp3=[LVHD3(:,1:8)...
    nan(I3,obs1+obs2) LVHD3(:,8+1:8+obs3) nan(I3,obs4+obs5)...
    nan(I3,obs1+obs2) LVHD3(:,8+obs3+1:8+2*obs3) nan(I3,obs4+obs5)];
AGMTXp4=[LVHD4(:,1:8)...
    nan(I4,obs1+obs2+obs3) LVHD4(:,8+1:8+obs4) nan(I4,obs5)...
    nan(I4,obs1+obs2+obs3) LVHD4(:,8+obs4+1:8+2*obs4) nan(I4,obs5)];
AGMTXp5=[LVHD5(:,1:8)...
    nan(I5,obs1+obs2+obs3+obs4) LVHD5(:,8+1:8+obs5)...
    nan(I5,obs1+obs2+obs3+obs4) LVHD5(:,8+obs5+1:8+2*obs5)];
AGMTX=[AGMTXp1;AGMTXp2;AGMTXp3;AGMTXp4;AGMTXp5];
obs=obs1+obs2+obs3+obs4+obs5;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Basic clean-up
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[I_pre,J_pre]=size(AGMTX);
revs_pre=sum(nansum(AGMTX(:,8+1:8+obs).*AGMTX(:,8+obs+1:8+2*obs)));
AGMTX=AGMTX(~isnan(AGMTX(:,8)),:);%drop if UPC=NaN
AGMTX=AGMTX(AGMTX(:,8)~=0,:);%drop if UPC=0
AGMTX=AGMTX(nanmin(AGMTX(:,8+1:8+obs),[],2)>0,:);%drop if sum(q)<=0
AGMTX=AGMTX(nanmin(AGMTX(:,8+obs+1:8+2*obs),[],2)>0,:);%drop if any p<0

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Aggregation by UPC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[MTX1]=agg2uniqueUPC_fn(AGMTX,8,8,1000);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generate country code from info in UPC code
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[MTX1_ccode]=countryID_v2_fn(MTX1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Aggregation by Material Code
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[MTX2]=agg2uniqueMatrlCode_fn(MTX1_ccode,9,5,0);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Correct product group labels
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MTX2=PcodeRelabel_fn(MTX2);

LVHD=MTX2;
save ../Data/aggdata LVHD -append