% this code collects the XLS data into one big matrix and does basic
% cleanup and aggergation
clear all
load ../Data/xlsdata

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Arrange matrices into a single matrix
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[I1,J1]=size(LVSM1); [I2,J2]=size(LVSM2); [I3,J3]=size(LVSM3);
obs1=(J1-8)/2; obs2=(J2-8)/2; obs3=(J3-8)/2;
AGMTXp1=[LVSM1(:,1:8+obs1) nan(I1,obs2+obs3) ...
    LVSM1(:,8+obs1+1:8+2*obs1) nan(I1,obs2+obs3)];
AGMTXp2=[LVSM2(:,1:8) nan(I2,obs1) LVSM2(:,8+1:8+obs2) nan(I2,obs3)...
    nan(I2,obs1) LVSM2(:,8+obs2+1:8+2*obs2) nan(I2,obs3)];
AGMTXp3=[LVSM3(:,1:8) nan(I3,obs1) nan(I3,obs2) LVSM3(:,8+1:8+obs3)...
    nan(I3,obs1) nan(I3,obs2) LVSM3(:,8+obs3+1:8+2*obs3)];
AGMTX=[AGMTXp1;AGMTXp2;AGMTXp3];
obs=obs1+obs2+obs3;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Basic clean-up
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[I_pre,J_pre]=size(AGMTX);
revs_pre=sum(nansum(AGMTX(:,8+1:8+obs).*AGMTX(:,8+obs+1:8+2*obs)));
AGMTX=AGMTX(~isnan(AGMTX(:,8)),:);%drop if UPC=NaN
AGMTX=AGMTX(AGMTX(:,8)~=0,:);%drop if UPC=0
AGMTX=AGMTX(nanmin(AGMTX(:,8+1:8+obs),[],2)>0,:);%drop if sum(q)<=0
AGMTX=AGMTX(nanmin(AGMTX(:,8+obs+1:8+2*obs),[],2)>0,:);%drop if any p<0

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Aggregation by UPC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[MTX1]=agg2uniqueUPC_fn(AGMTX,8,8,1000);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generate country code from info in UPC code
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[MTX1_ccode]=countryID_v2_fn(MTX1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Aggregation by Material Code
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[MTX2]=agg2uniqueMatrlCode_fn(MTX1_ccode,9,5,0);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Correct product group labels
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MTX2=PcodeRelabel_fn(MTX2);

LVSM=MTX2;
save ../Data/aggdata LVSM -append