%This code generates Figure 4
clear all

load Data/PandQdata

time=2007.25:0.25:2011.00;
FS=12;%FontSize
LW=2.5;%LineWidth
scle=1e+2;

%define store type
s=0;
DATAMTX=DATAMTX(DATAMTX(:,3)==s,:);

%Product code: 0=aggregate food
i=0;
MTX=DATAMTX(DATAMTX(:,2)==i,:);

%Back out data
aggP_geks=exp(cumsum([0;MTX(2:end,4)],1));
aggrev=MTX(:,6)./scle;
C=aggrev./aggP_geks;
var2=[C(5:end)'./C(1:end-4)'];

figure
plot(time,log([var2]'),...
    [2009.75 2009.75],[-0.25 0.25],'r:','LineWidth',LW)
text(2009.775,-0.2,'Crisis: 2009Q4/2008Q4','FontSize',11,'FontWeight','bold')
ylim([-0.25 0.25])
set(gca,'FontSize',FS)
hline(0,'k-')
xlim([2007.25 2011.0])
ylabel('Year-on-year log change in real food consumption')