%This code generates Figure 7
%examins the contribution of within and accross product group
%price changes to total price changes.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
load Data/PandQdata

FS=12;%FontSize
LW=2.5;%LineWidth
tline=2007.25:0.25:2011.0;
scle=1e+2;

%define store type
m=0;
DATAMTX=DATAMTX(DATAMTX(:,3)==m,:);
DATAMTXsum=DATAMTXsum(DATAMTXsum(:,2)==m,:);
i=0;
DATA=DATAMTX(ismember(DATAMTX(:,2),i),:);

%%%%%%%%%%%%%%%%%%%%%%%
seclist=unique(DATA(:,2));
N=length(seclist);
for i=1:N
    MTX=DATA(DATA(:,2)==seclist(i),:);
    dlp0(:,i)=MTX(2:end,4);
end
p0=exp(cumsum([zeros(1,N);dlp0],1));

%get sectoral data
%%%%%%%%%%%%%%%%%%%%%%
i=1000:9999;
DATA=DATAMTX(ismember(DATAMTX(:,2),i),:);
%%%%%%%%%%%%%%%%%%%%%%%
seclist=unique(DATA(:,2));
N=length(seclist);
for i=1:N
    MTX=DATA(DATA(:,2)==seclist(i),:);
    dlp(:,i)=MTX(2:end,4);
    dlpF(:,i)=MTX(2:end,9);
    s(:,i)=MTX(:,7);%g's share in total
    sF(:,i)=MTX(:,15);%foreign share in g
end

%decomposition at 4-digit level
s=s/100;
sF=sF/100;
wF=(s.*sF)./repmat(nansum(s.*sF,2),1,N);
P=repmat(p0,1,N);
p=exp(cumsum([zeros(1,N);dlp],1));
pF=exp(cumsum([zeros(1,N);dlpF],1));
dpF_p=log(pF(5:end,:)./p(5:end,:))-log(pF(1:end-4,:)./p(1:end-4,:));
dp_P=log(p(5:end,:)./P(5:end,:))-log(p(1:end-4,:)./P(1:end-4,:));
sumdpF_P=nansum(wF.*log(pF./P),2);
Pall=sumdpF_P(5:end)-sumdpF_P(1:end-4);
Pwithin=nansum(wF(1:end-4,:).*dpF_p,2);
Pacross=nansum(wF(1:end-4,:).*dp_P,2);

figure;
plot(tline,Pall,'-',tline,Pwithin,'-.',tline,Pacross,'--','LineWidth',LW)
set(gca,'FontSize',FS)
hline(0,'k-')
xlim([2007.25 2011.0])
ylim([-0.06 0.06])
ylabel('Y-o-y log change in relative price,    {\Delta}ln(P^{F}_{t}/P_{t})')
legend('Aggregate','Within','Across')