%This code generates Figure 9
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
load Data\dataAER_RR allLVAdata_dropIN_4secUV
MTX=allLVAdata_dropIN_4secUV;

%choose sectoral detail
sec_level=4;
hs=9;
T=(size(MTX,2)-hs)/2;

%loop to prepare, collect and plot the price level data
quantiles_cum=[];
for prodlev=sec_level%0:4 %Choose product level
    
    list=floor(1000/(10^(4-prodlev))):floor(9999/(10^(4-prodlev)));
    
    for ProdDef=list%list of feasible sectors
        
        %restrict MTX to the particular product
        MCtree_X=ProdDef*(10^(4-prodlev)):...
            ProdDef*(10^(4-prodlev))+floor(0.9999*(10^(4-prodlev)));
        MTX2=MTX(ismember(MTX(:,2),MCtree_X),:);
        
        if ~isempty(MTX2)==1%proceed only if MTX not empty
            N=size(MTX2,1);
            Q=MTX2(:,hs+1:hs+T)';
            P=MTX2(:,hs+T+1:hs+2*T)';
            if min(sum(~isnan(Q),2))>1 % at least 2 UPC items
                y = prctile(P,100*(0:0.25:1),2);
                qtl75_qtl25=y(:,4)./y(:,2);
                quantiles_cum=[quantiles_cum qtl75_qtl25];
            end
        end
    end
end

figure;
[n,xout]=hist(log(nanmean(quantiles_cum,1)),[0:0.12:2.5]);%mean over time for each group
bar(xout,n) 
FS=12;%FontSize
set(gca,'FontSize',FS)
xlim([-0.05 2.5])
ylabel('Frequency')
xlabel('Within-group unit value dispersion,ln(p^{i=75%}_{ig}/p^{i=25%}_{ig})')