%This code generates rows of Table 5 (row by row)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
load Data\dataAER_RR allLVAdata_dropIN_4secUV
MTX=allLVAdata_dropIN_4secUV;

% %switch this on for "Foreign"
%MTX=MTX(~ismember(MTX(:,9),[101 941]),:);

% %switch this on for "Domestic"
%MTX=MTX(ismember(MTX(:,9),[101 941]),:);

% %switch this on for "store products"
% load ..\CleanUp\Data\dataAER_RR allLVAdata_DONOTdropIN_4secUV
% MTX=allLVAdata_DONOT_dropIN_4secUV;
% MTX=MTX(ismember(MTX(:,9),[100]),:);

%choose sectoral detail
sec_level=4;

hs=9;
T=(size(MTX,2)-hs)/2;

%loop to prepare, collect and plot the price level data
quantiles_cum=[];
stdUV_UV_cum=[];
g=0;

for prodlev=sec_level%0:4 %Choose product level
    
    list=floor(1000/(10^(4-prodlev))):floor(9999/(10^(4-prodlev)));
    
    for ProdDef=list%list of feasible sectors
        
        %restrict MTX to the particular product
        MCtree_X=ProdDef*(10^(4-prodlev)):...
            ProdDef*(10^(4-prodlev))+floor(0.9999*(10^(4-prodlev)));
        MTX2=MTX(ismember(MTX(:,2),MCtree_X),:);
        
        if ~isempty(MTX2)==1%proceed only if MTX not empty
            N=size(MTX2,1);
            Q=MTX2(:,hs+1:hs+T)';
            P=MTX2(:,hs+T+1:hs+2*T)';
            Rmtx=P.*Q;
            
            if min(sum(~isnan(Q),2))>1
                %calculate the number of items in group by t
                g=g+1;
                temp=P';
                temp2=temp>0;
                temp3=sum(temp2,1);
                N_of_items(g,:)=temp3;
                
                Puv=nansum(Rmtx,2)./nansum(Q,2);
                y = prctile(P,100*(0:0.25:1),2);
                qtl75_qtl25=y(:,4)./y(:,2);
                qtl75_less_qtl25=y(:,4)-y(:,2);
                stdUV=nanstd(P,0,2);
                stdUV_UV=stdUV./Puv;
                quantiles_cum=[quantiles_cum qtl75_qtl25];
                stdUV_UV_cum=[stdUV_UV_cum stdUV_UV];
            end
        end
    end
end

disp('==UV dispersion statistics for Table 5==')
disp([log(median(nanmean(quantiles_cum,1)))...
    log(mean(nanmean(quantiles_cum,1)))...
    median(nanmean(stdUV_UV_cum,1))...
    median(median(N_of_items))])